//package com.gxzc.zen.orm
//
//import com.baomidou.mybatisplus.spring.MybatisSqlSessionFactoryBean
//import com.baomidou.mybatisplus.spring.boot.starter.MybatisPlusProperties
//import com.baomidou.mybatisplus.spring.boot.starter.SpringBootVFS
//import org.apache.ibatis.session.SqlSessionFactory
//import org.mybatis.spring.SqlSessionTemplate
//import org.mybatis.spring.annotation.MapperScan
//import org.slf4j.Logger
//import org.slf4j.LoggerFactory
//import org.springframework.beans.factory.annotation.Autowired
//import org.springframework.beans.factory.annotation.Qualifier
//import org.springframework.boot.autoconfigure.jdbc.DataSourceBuilder
//import org.springframework.boot.context.properties.ConfigurationProperties
//import org.springframework.context.annotation.Bean
//import org.springframework.context.annotation.Configuration
//import org.springframework.core.io.support.PathMatchingResourcePatternResolver
//import org.springframework.jdbc.datasource.DataSourceTransactionManager
//import javax.sql.DataSource
//
///**
// * Usage 数据源配置<br>
// * 扫描路径为 com.gxzc.zen.*.usage
// * @author NorthLan at 2018/1/26
// */
//@Configuration
//@MapperScan(basePackages = ["com.gxzc.zen.api.usage.mapper"], sqlSessionTemplateRef = UsageDataSourceConfig.SQL_SESSION_TEMPLATE_NAME)
//class UsageDataSourceConfig {
//    companion object {
//        const val DATASOURCE_NAME: String = "usageDataSource"
//        const val TRANSACTION_MANAGER_NAME: String = "usageTransactionManager"
//        const val SQL_SESSION_FACTORY_NAME: String = "usageSqlSessionFactory"
//        const val SQL_SESSION_TEMPLATE_NAME: String = "usageSqlSessionTemplate"
//        val logger: Logger = LoggerFactory.getLogger(UsageDataSourceConfig::class.java)
//    }
//
//    @Autowired
//    private lateinit var properties: MybatisPlusProperties
//
//    private val mapperLocation: String = "classpath:/mapping/usage/*.xml"
//
//    @Bean(DATASOURCE_NAME)
//    @ConfigurationProperties(prefix = "druid.datasource.usage")
//    fun dataSource(): DataSource {
//        return DataSourceBuilder.create().build()
//    }
//
//    @Bean(TRANSACTION_MANAGER_NAME)
//    fun transactionManager(@Qualifier(DATASOURCE_NAME) dataSource: DataSource): DataSourceTransactionManager {
//        return DataSourceTransactionManager(dataSource)
//    }
//
//    @Bean(SQL_SESSION_FACTORY_NAME)
//    fun sqlSessionFactory(@Qualifier(DATASOURCE_NAME) dataSource: DataSource): SqlSessionFactory {
//        return MybatisSqlSessionFactoryBean().let {
//            it.setDataSource(dataSource)
//            it.vfs = SpringBootVFS::class.java
//            it.setConfiguration(properties.configuration)
//            it.setGlobalConfig(properties.globalConfig.convertGlobalConfiguration())
//            it.setMapperLocations(PathMatchingResourcePatternResolver().getResources(mapperLocation))
//            it.`object`
//        }
//    }
//
//    @Bean(SQL_SESSION_TEMPLATE_NAME)
//    fun sqlSessionTemplate(@Qualifier(SQL_SESSION_FACTORY_NAME) sqlSessionFactory: SqlSessionFactory): SqlSessionTemplate {
//        return SqlSessionTemplate(sqlSessionFactory)
//    }
//}